/**
 * EasyBeans
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: CarFieldMetadataConfigurator.java 6167 2012-02-09 16:46:06Z sauthieg $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.ee.metadata.car.impl.configurator;

import java.util.List;

import org.ow2.util.ee.metadata.car.api.ICarClassMetadata;
import org.ow2.util.ee.metadata.car.api.ICarFieldMetadata;
import org.ow2.util.ee.metadata.car.api.ICarMethodMetadata;
import org.ow2.util.ee.metadata.car.impl.CarFieldMetadata;
import org.ow2.util.ee.metadata.common.impl.configurator.CommonFieldMetadataConfigurator;
import org.ow2.util.scan.api.configurator.metadata.specific.ISpecificClassConfigurator;
import org.ow2.util.scan.api.metadata.structures.JField;

/**
 * CarFieldMetadataConfigurator.
 * @author Gael Lalire
 */
public class CarFieldMetadataConfigurator extends
        CommonFieldMetadataConfigurator<ICarClassMetadata, ICarMethodMetadata, ICarFieldMetadata> {

    /**
     * Constructor.
     * @param jField signature
     * @param carClassMetadata parent
     * @param specificClassConfiguratorList specificClassConfiguratorList
     * @param annotationParsingDesactived annotationParsingDesactived
     */
    public CarFieldMetadataConfigurator(
            final JField jField,
            final ICarClassMetadata carClassMetadata,
            final boolean annotationParsingDesactived,
            final List<ISpecificClassConfigurator<ICarClassMetadata, ICarMethodMetadata, ICarFieldMetadata>>
                specificClassConfiguratorList) {
        super(new CarFieldMetadata(jField, carClassMetadata), specificClassConfiguratorList);
        if (!annotationParsingDesactived) {
            registerAnnotationVisitor();
        }
    }

}
